From a6a420228b970cbc2d3bf78e0615e0361f1eb8ea Mon Sep 17 00:00:00 2001
From: Alexander Polakov <plhk@sdf.org>
Date: Thu, 20 Dec 2012 18:06:01 +0400
Subject: [PATCH 04/11] Handle _NET_WM_STATE ClientMessage

Conflicts:
	xevents.c
---
 calmwm.h |  7 +++++++
 xutil.c  | 37 +++++++++++++++++++++++++++++++++++++
 2 files changed, 44 insertions(+)

diff --git a/calmwm.h b/calmwm.h
index 923bde9..f11c8e9 100644
--- a/calmwm.h
+++ b/calmwm.h
@@ -497,6 +497,8 @@ void			 xu_ewmh_net_desktop_names(struct screen_ctx *, char *,
 
 void			 xu_ewmh_net_wm_desktop(struct client_ctx *);
 Atom 			*xu_ewmh_get_net_wm_state(struct client_ctx *, int *);
+void 			 xu_ewmh_handle_net_wm_state_msg(struct client_ctx *,
+				 int, Atom , Atom);
 void 			 xu_ewmh_set_net_wm_state(struct client_ctx *);
 void 			 xu_ewmh_restore_net_wm_state(struct client_ctx *);
 
@@ -557,6 +559,11 @@ enum {
 	_NET_CLOSE_WINDOW,
 	EWMH_NITEMS
 };
+enum {
+	_NET_WM_STATE_REMOVE,
+	_NET_WM_STATE_ADD,
+	_NET_WM_STATE_TOGGLE
+};
 struct atom_ctx {
 	char	*name;
 	Atom	 atom;
diff --git a/xutil.c b/xutil.c
index 49d8c36..be9ab37 100644
--- a/xutil.c
+++ b/xutil.c
@@ -438,6 +438,43 @@ xu_ewmh_get_net_wm_state(struct client_ctx *cc, int *n)
 }
 
 void
+xu_ewmh_handle_net_wm_state_msg(struct client_ctx *cc, int action, Atom first,
+		Atom second)
+{
+	int i;
+	static struct handlers {
+		int atom;
+		int property;
+		void (*toggle)(struct client_ctx *);
+	} handlers[] = {
+		{ _NET_WM_STATE_MAXIMIZED_VERT,
+			CLIENT_VMAXIMIZED,
+			client_vertmaximize },
+		{ _NET_WM_STATE_MAXIMIZED_HORZ,
+			CLIENT_HMAXIMIZED,
+			client_horizmaximize },
+	};
+
+	for (i = 0; i < nitems(handlers); i++) {
+		if (first != ewmh[handlers[i].atom].atom &&
+		    second != ewmh[handlers[i].atom].atom)
+		       continue;
+		switch (action) {
+		case _NET_WM_STATE_ADD:
+			if ((cc->flags & handlers[i].property) == 0)
+			    handlers[i].toggle(cc);
+			break;
+		case _NET_WM_STATE_REMOVE:
+			if (cc->flags & handlers[i].property)
+				handlers[i].toggle(cc);
+			break;
+		case _NET_WM_STATE_TOGGLE:
+			handlers[i].toggle(cc);
+		}
+	}
+}
+
+void
 xu_ewmh_restore_net_wm_state(struct client_ctx *cc)
 {
 	Atom *atoms;
-- 
1.8.1.2

